require 'rspec'
require 'check_host/check_host_ip'

RSpec.describe CheckHostIp, '#initialize' do

  HOST_NAME = 'fawazalhokairfashion.com'
  HOST_IP   = '91.109.13.176'
  let(:check_host) { CheckHostIp.new(HOST_NAME, HOST_IP)}

  context 'with initialization' do
    it 'should be an instance of CheckHost' do
      expect(check_host).to be_a CheckHostIp
    end

    it 'should return host' do
      expect(check_host.host).to eq HOST_NAME
    end

    it 'should return the result from the host command' do
      expect(check_host.cmd).to eq "#{HOST_NAME} has address #{HOST_IP}\n"
    end

  end

  context 'with results' do
    it 'should return no result if IP has not changed' do
      expect(check_host.result?).to eq false
    end

    it 'should return true if IP has changed' do
      CHANGED_IP    = '8.8.8.8'
      check_host.ip = CHANGED_IP
      expect(check_host.result?).to eq true
    end
  end

  context 'with notification' do
    skip('just skipping so as not to get email notifications every second')
    # it 'should raise an alert if IP has changed' do
    #   ANOTHER_CHANGED_IP = '9.9.9.9'
    #   check_host.ip = ANOTHER_CHANGED_IP
    #   expect(check_host.notify).to eq true
    # end
  end
end
